﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using StudentsBusiness;

namespace StudentManagementStudio
{
    public partial class EditStudent : Form
    {
        Student _editStudent;

        public EditStudent(Student editStudent)
        {
            InitializeComponent();
            _editStudent = editStudent;
            loadStudent();
        }

        private void loadStudent()
        {
            studentIDValueLabel.Text = _editStudent.StudentID.ToString();
            studentNameTextBox.Text = _editStudent.StudentName;
            if (_editStudent.StudentDescriptionText != null)
            {
                descriptionTextBox.Text = _editStudent.StudentDescriptionText;            
            }
            class1TextBox.Text = _editStudent.Class1;
            if (_editStudent.Class2 != null)
            {
                class2TextBox.Text = _editStudent.Class2;            
            }
            if (_editStudent.Class3 != null)
            {
                class3TextBox.Text = _editStudent.Class3;
            }
            if (_editStudent.Class4 != null)
            {
                class4TextBox.Text = _editStudent.Class4;
            }
            if (_editStudent.Class5 != null)
            {
                class5TextBox.Text = _editStudent.Class5;
            }
            if (_editStudent.StudentImage != null)
            {
                studentImageTextBox.Text = _editStudent.StudentImage;            
            }
            statusTextBox.Text = _editStudent.Status;
            dateTimePicker.Value = _editStudent.EnteredDate;
            rankingMaskedTextBox.Text = _editStudent.Ranking.ToString();
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void saveButton_Click(object sender, EventArgs e)
        {
            //if validation was ok
            if (validate())
            {
                //create new object and save to the db
                saveToDb();
                this.Close();            
            }
        }

        private void saveToDb()
        {
            StudentMapper mapper = new StudentMapper();
            Student editStudent = new Student();

            editStudent.StudentID = _editStudent.StudentID;
            editStudent.StudentName = studentNameTextBox.Text;
            if (descriptionTextBox.Text != string.Empty)
            {
                editStudent.StudentDescriptionText = descriptionTextBox.Text;            
            }
            editStudent.Class1 = class1TextBox.Text;
            if (class2TextBox.Text != string.Empty)
            {
                editStudent.Class2 = class2TextBox.Text;            
            }
            if (class3TextBox.Text != string.Empty)
            {
                editStudent.Class3 = class3TextBox.Text;
            }
            if (class4TextBox.Text != string.Empty)
            {
                editStudent.Class4 = class4TextBox.Text;
            }
            if (class5TextBox.Text != string.Empty)
            {
                editStudent.Class5 = class5TextBox.Text;
            }
            if (studentImageTextBox.Text != string.Empty)
            {
                editStudent.StudentImage = studentImageTextBox.Text;
            }
            editStudent.Status = statusTextBox.Text;
            editStudent.EnteredDate = dateTimePicker.Value;
            editStudent.Ranking = int.Parse(rankingMaskedTextBox.Text);
            
            mapper.updateStudent(editStudent);
        }

        private bool validate()
        {
            //check for problems
            if (studentNameTextBox.Text == string.Empty)
            {
                MessageBox.Show("Student name is required.");
                return false;
            }
            if (class1TextBox.Text == string.Empty)
            {
                MessageBox.Show("Class 1 is required.");
                return false;
            }
            if (statusTextBox.Text == string.Empty)
            {
                MessageBox.Show("Status is required.");
                return false;
            }
            //dateTimePicker doesn't seem to be emptyable
            if (rankingMaskedTextBox.Text == string.Empty)
            {
                MessageBox.Show("Ranking is required.");
                return false;
            }
            else 
            {
                if (int.Parse(rankingMaskedTextBox.Text) < 1)
                {
                    MessageBox.Show("Student must rank 1st or less (2nd, 3rd, 4th, etc..).");
                    return false;
                }            
            }
            return true;        
        }

        private void findFileButton_Click(object sender, EventArgs e)
        {
            DialogResult result = openFileDialog.ShowDialog();
            if (result == DialogResult.OK) // Test result.
            {
                studentImageTextBox.Text = openFileDialog.SafeFileName;
            }
        }

    }
}
